> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Unshare Resource With Principal

> Removes direct access for a principal (user or service account) from a resource.

`Unary` · [`Groups`](/docs/api-reference/generated/group/overview)

Removes direct access for a principal (user or service account) from a resource.

Use this method to:

* Revoke a principal's direct access to a resource
* Remove sharing without affecting group-based access

### Examples

* Remove user access from a runner:

  Revokes a user's direct access to a runner.

  ```yaml theme={null}
  resourceType: RESOURCE_TYPE_RUNNER
  resourceId: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  principal: PRINCIPAL_USER
  principalId: "f53d2330-3795-4c5d-a1f3-453121af9c60"
  ```

### Authorization

Requires admin role on the specific resource.

## Endpoint

```text theme={null}
POST /api/gitpod.v1.GroupService/UnshareResourceWithPrincipal
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.GroupService/UnshareResourceWithPrincipal" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "resourceType": "RESOURCE_TYPE_ENVIRONMENT"
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.event_pb2 as event_pb2
  import gitpod.v1.group_pb2 as group_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = group_pb2.UnshareResourceWithPrincipalRequest(
      resource_type=event_pb2.RESOURCE_TYPE_ENVIRONMENT,
  )
  response = ona.services.group.unshare_resource_with_principal(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { ResourceType } from "@gitpod/sdk/gitpod/v1/event_pb";
  import { UnshareResourceWithPrincipalRequestSchema } from "@gitpod/sdk/gitpod/v1/group_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(UnshareResourceWithPrincipalRequestSchema, {
      resourceType: ResourceType.ENVIRONMENT,
    });
    const response = await ona.services.group.unshareResourceWithPrincipal(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.UnshareResourceWithPrincipalRequest{
  		ResourceType: gitpodpb.ResourceType_RESOURCE_TYPE_ENVIRONMENT,
  	})
  	response, err := ona.Services.Group.UnshareResourceWithPrincipal(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "resourceType": "RESOURCE_TYPE_ENVIRONMENT"
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.UnshareResourceWithPrincipalRequest`

UnshareResourceWithPrincipal messages

| Field          | Type                                          | Required | Description                                                                                                                    |
| -------------- | --------------------------------------------- | -------- | ------------------------------------------------------------------------------------------------------------------------------ |
| `resourceType` | [ResourceType](#enum-gitpod-v1-resource-type) | No       | Type of resource to unshare Constraints: `enum.defined_only=true, enum.not_in=0`.                                              |
| `resourceId`   | string                                        | No       | ID of the resource to unshare Constraints: `string.uuid=true`.                                                                 |
| `principal`    | [Principal](#enum-gitpod-v1-principal)        | No       | Type of principal to remove access from (user or service account) Constraints: `enum.defined_only=true, enum.in=2, enum.in=5`. |
| `principalId`  | string                                        | No       | ID of the principal (user or service account) to remove access from Constraints: `string.uuid=true`.                           |

## Response

`gitpod.v1.UnshareResourceWithPrincipalResponse`

This message has no fields.

## Related types

<a id="enum-gitpod-v1-principal" />

<Accordion title="Principal">
  | Value                       | Number | Description |
  | --------------------------- | -----: | ----------- |
  | `PRINCIPAL_UNSPECIFIED`     |      0 |             |
  | `PRINCIPAL_ACCOUNT`         |      1 |             |
  | `PRINCIPAL_USER`            |      2 |             |
  | `PRINCIPAL_RUNNER`          |      3 |             |
  | `PRINCIPAL_ENVIRONMENT`     |      4 |             |
  | `PRINCIPAL_SERVICE_ACCOUNT` |      5 |             |
  | `PRINCIPAL_RUNNER_MANAGER`  |      6 |             |
</Accordion>

<a id="enum-gitpod-v1-resource-type" />

<Accordion title="ResourceType">
  | Value                                        | Number | Description |
  | -------------------------------------------- | -----: | ----------- |
  | `RESOURCE_TYPE_UNSPECIFIED`                  |      0 |             |
  | `RESOURCE_TYPE_ENVIRONMENT`                  |      1 |             |
  | `RESOURCE_TYPE_RUNNER`                       |      2 |             |
  | `RESOURCE_TYPE_PROJECT`                      |      3 |             |
  | `RESOURCE_TYPE_TASK`                         |      4 |             |
  | `RESOURCE_TYPE_TASK_EXECUTION`               |      5 |             |
  | `RESOURCE_TYPE_SERVICE`                      |      6 |             |
  | `RESOURCE_TYPE_ORGANIZATION`                 |      7 |             |
  | `RESOURCE_TYPE_USER`                         |      8 |             |
  | `RESOURCE_TYPE_ENVIRONMENT_CLASS`            |      9 |             |
  | `RESOURCE_TYPE_RUNNER_SCM_INTEGRATION`       |     10 |             |
  | `RESOURCE_TYPE_HOST_AUTHENTICATION_TOKEN`    |     11 |             |
  | `RESOURCE_TYPE_GROUP`                        |     12 |             |
  | `RESOURCE_TYPE_PERSONAL_ACCESS_TOKEN`        |     13 |             |
  | `RESOURCE_TYPE_USER_PREFERENCE`              |     14 |             |
  | `RESOURCE_TYPE_SERVICE_ACCOUNT`              |     15 |             |
  | `RESOURCE_TYPE_SECRET`                       |     16 |             |
  | `RESOURCE_TYPE_SSO_CONFIG`                   |     17 |             |
  | `RESOURCE_TYPE_DOMAIN_VERIFICATION`          |     18 |             |
  | `RESOURCE_TYPE_AGENT_EXECUTION`              |     19 |             |
  | `RESOURCE_TYPE_RUNNER_LLM_INTEGRATION`       |     20 |             |
  | `RESOURCE_TYPE_AGENT`                        |     21 |             |
  | `RESOURCE_TYPE_ENVIRONMENT_SESSION`          |     22 |             |
  | `RESOURCE_TYPE_USER_SECRET`                  |     23 |             |
  | `RESOURCE_TYPE_ORGANIZATION_POLICY`          |     24 |             |
  | `RESOURCE_TYPE_ORGANIZATION_SECRET`          |     25 |             |
  | `RESOURCE_TYPE_PROJECT_ENVIRONMENT_CLASS`    |     26 |             |
  | `RESOURCE_TYPE_BILLING`                      |     27 |             |
  | `RESOURCE_TYPE_PROMPT`                       |     28 |             |
  | `RESOURCE_TYPE_COUPON`                       |     29 |             |
  | `RESOURCE_TYPE_COUPON_REDEMPTION`            |     30 |             |
  | `RESOURCE_TYPE_ACCOUNT`                      |     31 |             |
  | `RESOURCE_TYPE_INTEGRATION`                  |     32 |             |
  | `RESOURCE_TYPE_WORKFLOW`                     |     33 |             |
  | `RESOURCE_TYPE_WORKFLOW_EXECUTION`           |     34 |             |
  | `RESOURCE_TYPE_WORKFLOW_EXECUTION_ACTION`    |     35 |             |
  | `RESOURCE_TYPE_SNAPSHOT`                     |     36 |             |
  | `RESOURCE_TYPE_PREBUILD`                     |     37 |             |
  | `RESOURCE_TYPE_ORGANIZATION_LLM_INTEGRATION` |     38 |             |
  | `RESOURCE_TYPE_CUSTOM_DOMAIN`                |     39 |             |
  | `RESOURCE_TYPE_ROLE_ASSIGNMENT_CHANGED`      |     40 |             |
  | `RESOURCE_TYPE_GROUP_MEMBERSHIP_CHANGED`     |     41 |             |
  | `RESOURCE_TYPE_WEBHOOK`                      |     42 |             |
  | `RESOURCE_TYPE_SCIM_CONFIGURATION`           |     43 |             |
  | `RESOURCE_TYPE_SERVICE_ACCOUNT_SECRET`       |     44 |             |
  | `RESOURCE_TYPE_ANNOUNCEMENT_BANNER`          |     45 |             |
  | `RESOURCE_TYPE_SERVICE_ACCOUNT_TOKEN`        |     46 |             |
  | `RESOURCE_TYPE_ROLE_ASSIGNMENT`              |     47 |             |
  | `RESOURCE_TYPE_WARM_POOL`                    |     48 |             |
  | `RESOURCE_TYPE_NOTIFICATION`                 |     49 |             |
  | `RESOURCE_TYPE_SECURITY_POLICY`              |     50 |             |
</Accordion>
